$MOD52
$TITLE(BYTE SIGNED MULTIPLY)
$PAGEWIDTH(132)
$DEBUG
$OBJECT
$NOPAGING



;DULEZITE !!!! pro potreby doladeni s monitorem docasne zruseno odstaveni preruseni od seriove linky
;v 2. radku (spravne 8FH) a odstrednikovano cele nastaveni casovace 2 + zmena v pocatku souboru source1.asm kvuli vlozeni monitoru.




 
;upravy provedene 19.12.99 - zmenena obsluha tlacitek kvuli umisteni na plosnaku t.zn. 
;anody	=		1	2	4	8
;odpovidajici funkce= dotaz  mod   down  up

 
$include(source1.asm)

start:MOV TMOD,#11H			;nastav mod 1 citace 0 a 1=16 bitove citace
	MOV IE,#8FH			;povol preruseni od casovace 0,1, vnejsi INT obe i globalne
	CLR IT0				;nastav aktivaci vnejsiho preruseni "0" urovni
	CLR IT1				;nastav aktivaci vnejsiho preruseni "1" urovni
	MOV R3,#0H	
	MOV IP,#10H			;nastav prioritu INT-nejvyssi od ser.kanalu
	CLR 	A			;nuluj ACC
	MOV cit_kmh,A			;nuluj promenne
	MOV cit_pal10,A
	MOV cit_pal20,A
	MOV cit_pal30,A		
	MOV tecka,#0H			;zhasni tecku
	SETB P1.0			;testovani tlacitek
	SETB P1.1			;spust/zastav provozni cas
	CLR P3.4			;vystup nulovani latch "draha"
	CLR P3.5			;vystup nulovani latch "palivo"
	SETB P1.3			;vstup do PD mode
	MOV 20H,#00000001B		;inicializace bitove adresovanych promennych
	MOV 21H,#0B
	MOV 22H,#0B
	MOV 23H,#00000010B
	MOV schov_4,#0FFH		;pocatecni data pro casovaci smycku loga
	MOV schov_5,#0FH		;-------------//--------------
	MOV RCAP2H,#0FFh		;nastaveni casovace 2 pro seriovy kanal (rychlost 86k)
	MOV RCAP2L,#0FCH
	MOV SCON,#54H			;nastaveni konfigurace cit/casovace 2
	MOV T2CON,#34H	

;----------------------Inicializace promennych displeje-----------

	MOV DPTR,#tablogo		;uloz do DPTR pocatecni adresu tabulky znaku
	MOV dis,#0EEH			;zhasni displej	
	MOV dis+1,#0EEH			;-----//------
	LCALL wav_den			;nastav parametry PCM pro uvodni hlaseni
	CLR P1.2			;aktivuj CS RTC
	MOV R0,#0FDH			;aktivuj RTC-viz protokol obsazeni bytu RTC
	MOV A,#00H		
	MOVX @R0,A
	INC R0
	MOV A,#02H
	MOVX @R0,A
	INC R0
	MOV A,#04H
	MOVX @R0,A
	SETB P1.2			;deaktivuj CS RTC
	
;-------------------------Program displeje------------------

zac:	MOV anody,#10H         		;uloz do "anody" kod prvni anody pred rotaci
	MOV R1,#dis			;nacti pocatecni adresu "dis" do R1
pokr_03:JB P1.3,pokr_89			;pokud neni pozadavek vstupu do "power down mode",pokracuj
	MOV PCON,#72H			;rizeni napajeni
pokr_89:MOV A,anody           		;nacti obsah anod do ACC
	RR A                   		;rotuj ACC doprava 
	JNZ pokr_00             	;pokud neni 0,skok na pokr_0
	MOV A,#08H			;uloz do anod znovu pocatecni data
pokr_00:MOV anody,A			;uloz aktualni stav anod
	JNB logo_bit,pokr_93		;pri prvnim vstupu po resetu je priznak nastaven=vstup do loga
	LJMP logo			;po resetu prechod do loga
pokr_93:MOV A,fce			;nacti byte pozadavku vykonavane fce
	CJNE A,#1H,pokr_41		;a zacni porovnavat
	SETB pozedi			;povol moznost editace
	LCALL wav_real			;rutina ulozeni adres PCM
	LJMP real			;realny cas (hodiny,minuty)
pokr_41:JB shift_bit,pokr_70		;pokud je priznak pozadavku druheho menu->skok na nej
	CJNE A,#2H,pokr_42
	CLR pozedi
	LCALL wav_provoz
	LJMP p_time			;provozni cas (vteriny,minuty-minuty,hodiny)
pokr_42:CJNE A,#3H,pokr_43
	CLR pozedi	
	LCALL wav_draha
	LJMP draha			;draha (km)
pokr_43:CJNE A,#4H,pokr_44
	CLR pozedi
	LCALL wav_okamzita_r
	LJMP kmh			;okamzita rychlost (km/h)
pokr_44:CJNE A,#5H,pokr_58
	CLR pozedi
	LCALL wav_prumerna_r
	LJMP p_kmh			;prumerna rychlost (km/h)
pokr_58:CJNE A,#6H,pokr_59
	CLR pozedi
	LCALL wav_okamzita_s
	LJMP ok_spot			;okamzita spotreba (l/100km nebo l/hod.)
pokr_59:CJNE A,#7H,pokr_60
	CLR pozedi
	LCALL wav_prumerna_s
	LJMP prum_spot			;prumerna spotreba (l/100km s ohledem na ujetou drahu)	
pokr_60:CJNE A,#8,pokr_64
	SETB pozedi
	LCALL wav_zuspal
	CLR wav3_bit
	LJMP zus_pal			;zustatek paliva (l,moznost nastaveni rezervy)
pokr_64:MOV fce,#1H			;dosazeno,zadej data pro zobrazeni prvni fce
	LCALL wav_real
	SJMP pokr_99
	
;------------Vyvolavani funkci po stisku NUL resp. SHIFT-----

pokr_70:SETB submenu_bit		;nastav priznak pritomnosti v submenu
	CJNE A,#2H,pokr_66
	SETB pozedi
	LJMP dat_den			;datum dne
pokr_66:CJNE A,#3H,pokr_67
	SETB pozedi
	LJMP dat_mes			;datum mesice
pokr_67:CJNE A,#4H,pokr_68
	SETB pozedi
	LJMP dat_rok			;datum roku
pokr_68:CJNE A,#5H,pokr_69
	SETB pozedi
	LJMP dvt			;den v tydnu
pokr_69:MOV fce,#1H			;zadej data pro zobrazeni prvni fce
	LCALL wav_real
	CLR submenu_bit			;nuluj priznak pritomnosti v submenu
	CLR shift_bit			;nuluj priznak pro vyvolani teto subrutiny 
	SJMP pokr_99

 pokr_99:MOV R2,anody			;uloz do R2 anody pro dalsi zpracovani
	CJNE R2,#2,pokr_04		;pokud nejsou "anody" = 2,skok dale
	INC R1				;jsou-li zacni nacitat dalsi byte pro zobrazeni
pokr_04:CJNE R2,#8,test_0		;nejsou-li "anody" = 8,testuj dale
	MOV R2,#0F0H			;jsou = 8,zadej parametr maskovani
	MOV R0,#uloz_4			;nacti do R0 adresu uloz4
	JB blik_bit4,pokr_19		;testuj pozadavek blikani
	SJMP pokr_05			;pokracuj
test_0:CJNE R2,#4,test_01		;nejsou-li "anody" = 4,testuj dale
	MOV R2,#0FH			;jsou = 4,zadej parametr pro maskovani
	MOV R0,#uloz_3		
	JB blik_bit3,pokr_19
	SJMP pokr_05
test_01:CJNE R2,#2,test_02		;nejsou-li "anody" = 2,testuj dale
	MOV R2,#0F0H			;jsou = 2,zadej parametr pro maskovani
	MOV R0,#uloz_2
	JB blik_bit2,pokr_19
	SJMP pokr_05
test_02:MOV R2,#0FH			;posledni anoda (1) se netestuje
	MOV R0,#uloz_1
	JNB blik_bit1,pokr_05
pokr_19:JNB blik_bit0,pokr_05		;pokud je u uvedene cifry pozadavek jejiho blikani,testuj bit blik_bit0
	MOV A,#0EH			;a pokud je aktivni,zadej do katody reprezentaci prazdneho znaku dle DPTR
	SJMP pokr_26			;a pokracuj bez vymaskovani
pokr_05:MOV A,@R1			;nacti do ACC obsah "dis"
	ANL A,R2			;proved vymaskovani ACCumulatoru
	CJNE R2,#0F0H,pokr_06		;test,zda provest SWAP ACC nebo ne
	SWAP A				;prohod horni a dolni nibble ACC
pokr_06:MOV @R0,A			;do adr. v R0 (uloz_1 az 4)uloz odpovidajici katody		
pokr_26:MOV katody,A			;uloz katody
	LCALL nuly			;skok na rutinu zhasnuti bezvyznamnych nul
	MOV A,katody
	MOVC A,@A+DPTR         		;vyhledej v tabulce reprezentaci tohoto cisla
	PUSH ACC               		;schovej ACC

;--------------------Zhasnuti cislice---------------

	MOV A,#0FFH            		;nuluj ACC
	MOV R0,#0E0H			;do R0 adr. latch registru anod
	MOVX @R0,A            		;zhasni cislo
;---------------------------------------------------

	MOV A,anody            		;nacti zpet anody
	CJNE A,#1H,pokr_71		;pokud neni pozadavek rozsviceni posledni cifry - preskoc
	JNB shift_bit,pokr_71		;pokud neni pozadavek vedlejsiho menu - preskoc
	MOV A,fce			;nacti zobrazovanou fci 
	CJNE A,#1H,pokr_71		;pokud je jina nez realtime,tecku u posledni cifry nezobrazuj
	MOV tecka,#1H			;jinak ji rozsvit
pokr_71:MOV A,anody			;nacti zpet anody
	XRL A,tecka             	;zjisti zda je u aktualniho cisla pozadavek tecky
	JNZ pokr_01             	;neni-li skok na pokr_1
	POP ACC                 	;je - vyber ACC
	ADD A,#080H             	;secti reprezentaci cisla a des. tecky
	SJMP pokr_02            	;obskoc vyber ACC bez tecky
pokr_01:POP ACC               		;vyber ACC
pokr_02:CPL A                 		;neguj reprezentaci cisla /kvuli spol. anode
	MOV R0,#0D0H            	;vloz do R0 adresu latch registru segmentu
	MOVX @R0,A              	;posli do nej data
	MOV A,anody             	;do ACC cislo displeje /anody/
	CPL A
	MOV R0,#0E0H			;do R0 adresu latch registru anod
	MOVX @R0,A           		;prvni cislo sviti

	JB logo_bit,pokr_75		;pri vypisovani loga netestuj tlacitka
	JNB wav2_bit,pokr_116		;pokud neni pozadavek identifikace fce,pokracuj testem tlacitek
	LJMP dotaz			;jinak zavolej na PCM aby taky neco delalo
pokr_116:JNB P1.0,tlacstisk		;jestlize neni zadne tl. stisknuto pokracuj
	MOV A,anody			;nacti do A anody
	CJNE A,#04,test_07		;pokud nejsou =1 skok na dalsi test
	CLR zpomal_1			;-tlacitko DOWN bylo uvolneno,nuluj priznak casovaci smycky
	LJMP pokr_16
test_07:CJNE A,#08,test_08		;pokud nejsou =2 skok na dalsi test
	CLR zpomal_0			;-tlacitko UP bylo uvolneno,nuluj priznak		
	LJMP pokr_16
test_08:CJNE A,#01H,test_09		;pokud nejsou =4 skok na dalsi test
	CLR zpomal_2			;tlacitko DOTAZ bylo uvolneno-nuluj priznak
	LJMP pokr_16
test_09:CJNE A,#02H,pokr_73		;pokud nejsou 8,pokracuj ven (tento test proto,aby se jine cislo 4,2,1 neidentifikovalo jako rozepnuti tlacitka)
	MOV A,ttlac			;nacti do ACC obsah byte "ttlac" - je to doba stisknuti tlacitka ENTER/MODE
	CJNE A,#0FFH,pokr_18		;test ttlac,zda naposledy vykonana fce byla prechod do editu
	MOV ttlac,#0			;= pak nuluj ttlac
	LJMP pokr_16
pokr_18:JZ pokr_73			;pokud je ACC = 0 nedelej nic a skoc na pokracovani
	MOV ttlac,#0H			;pokud neni nuluj ttlac
	JNB edit,dalsifce		;pokud nejsi v editaci skok na rutinu dalsifce - volba dalsi funkce pocitace
	LCALL dalsi			;pokud jsi v editaci nastav bit potvrzeni (pro prechod na dalsi cifru resp vystup z editace)
pokr_73:LJMP pokr_16
dalsifce:CLR pom_bit			;nuluj flag pro puleni dlouhych rutin
	INC fce				;zvys ukazatel dalsi pozadovane fce
	SETB wav2_bit			;nastav priznak vyvolani "dotaz" po prechodu do dalsi fce
	SJMP pokr_73

;--------------------Subrutina osetreni pri stisku tlacitka-------------

tlacstisk:MOV A,anody			;nacti anody
	CJNE A,#04H,pokr_13		;podle jejich obsahu zjisti stisknute tlacitko-bylo TL pri anodach=1?
	JB edit,down			;ano-pokud se nachazim v editaci je vyznam tlacitka "DOWN"
	SJMP nul_all			;ano-nenachazim se v editaci-je vyznam tlacitka "nul_all" (nuluj vse)
pokr_13:CJNE A,#08H,pokr_14		;jsou anody=2?
	JB edit,up			;ano-pokud se nachazim v editaci je vyznam tlacitka "UP"
	SJMP nul			;ano-nenachazim se v editaci-je vyznam tlacitka "nul"(nuluj navolenou fci,pokud je to mozno)
pokr_14:CJNE A,#01H,pokr_61		;zde je casovaci smycka,aby se po stlaceni tlac. nevykonal enter,a po vystupu z editu ihned dotaz
	JNB zpomal_2,pokr_74		;nejprve se 1x vykona rutina a pokud se tlacitko neuvolni,provadi se znovu az po dobe smycky
	DJNZ R4,pokr_75			;popis rutiny viz u rutin UP/DOWN
pokr_74:SETB zpomal_2
	MOV R4,#0FFH
	JB edit,ven
	SJMP dotaz
pokr_75:LJMP pokr_24
pokr_61:MOV A,ttlac			;casova smycka pro rozliseni kratkeho a dlouheho stisku TL MODE/ENTER
	CJNE A,#0FFH,pokr_17	
 	JNB pozedi,pokr_16		;smycka dobehla az do konce,testuj moznost editace v teto fci 
	JB edit,pokr_16			;pokud uz v editaci jsi,nereaguj
	SETB edit			;pokud v editaci nejsi pak nastav bit pro spusteni editace
	CLR obeh_bit			;nuluj priznak 
	CLR jednicky
	MOV A,fce			;nacti fci
	CJNE A,#1H,pokr_103		;pokud jde o hodiny realtimu,vloz do nast 1
	MOV nast,#1H
	SJMP pokr_16
pokr_103:JB submenu_bit,pokr_102	;pokud jde o submenu,do nast vloz 10
	MOV nast,#10H
	SJMP pokr_16		
pokr_102:CJNE A,#5H,pokr_105		;pokud jde o submenu a fci dvt zadej 22
	MOV nast,#22H
	SJMP pokr_16
pokr_105:MOV nast,#01H			;pokud nejde ani o jednu fci,nastav 1
	SJMP pokr_16
pokr_17:INC A				;-----//-----
	MOV ttlac,A			;ulozeni aktualizovaneho ttlac 
	SJMP pokr_16

;-------------Nastaveni priznaku--------
down:	SETB down_bit			;bit pro volani down mode
	SJMP pokr_16
up:	SETB up_bit			;bit pro volani up mode
	SJMP pokr_16
nul_all:CLR err_bit
	MOV vt_prov,#0			;je pozadavek nulovani-nuluj byte provoznich vterin
	MOV min_prov,#0			;--//---    prov. minut
	MOV hod_prov,#0			;--//---    prov. hodin
	MOV drh_1,#0H
	MOV drh_2,#0H
	MOV drh_3,#0H
	SJMP pokr_16
nul:	SETB nul_bit		
	SJMP pokr_16	
dotaz:	CLR wav2_bit
	JB shift_bit,pokr_16		;pokud jsem v submenu,neprovadej nic pri pozadavku dotaz
	JB wav_bit,pokr_16		;testuj flag wav_bit=pokud se stiskne tlacitko v prubehu vysilani zpravy nedelej nic.(Jinak by se zacala zprava vysilat znovu od zacatku jeste pred dokoncenim) Nuluje se az po dokonceni vysilani.
	CLR wav1_bit
	MOV IE,9FH			;povol INT od seriove linky
	SETB TI				;volej vysilani (vyuzito volani pres softwarove nastaveni priznaku INT)
	SJMP pokr_16	

;----------Rutina volani ulozeni editovanych hodnot-----------
ven:	CLR edit			;nuluj priznak editace
	CLR blik_bit1			;nuluj priznaky pro blikani cifer
	CLR blik_bit2
	CLR blik_bit3
	CLR blik_bit4
	SETB uloz_bit			;nastaveni priznaku pozadavku ulozeni
	MOV A,fce			;pro nastaveni hodin v zajmu co nejrychlejsiho nastaveni
	CJNE A,#1H,pokr_16		;se provadi ulozeni primo zde-nacti fci
	LCALL uloz_real			;pokud jde o real time skok na ulozeni,jinak pokracuj
	SJMP pokr_16


;--------------------Subrutina nastaveni UP,DOWN----------------------
pokr_16:JB edit,pokr_27			;testuj zda jsem v editaci
	LJMP pokr_24			;jinak skok na pokracovani
pokr_27:JNB submenu_bit,pokr_106	;pokud nejsem v submenu
pokr_108:MOV A,dis+1			;pokud jsem,nacti dis+1
	SJMP pokr_107
pokr_106:JB obeh_bit,pokr_108		;a neni priznak pro volani dis+1,nacti dis
	MOV A,dis			;pri nulovem priznaku nacti dis+1
pokr_107:MOV schov_2,A 			;uschovej dis nebo dis+1
	JB up_bit,pokr_111		;testuj pozadavek nahoru nebo dolu
	JB down_bit,pokr_115
	LJMP pokr_109			;pokud neni pozadavek UP ani DOWN preskoc celou subrutinu

;--------------------Rutina  UP-----------------------
pokr_111:CLR up_bit			;nuluj priznak
	JNB zpomal_0,pokr_63		;pri stisku tlacitka se nacte do R4 (FFh) a 1x se provede rutina a nastavi se zpomal_bit
	DJNZ R4,pokr_109		;pokud je tlacitko dale stisknute,dekrementuje se R4 (t.j. delsi smycka).Po dosazeni 00h
	MOV R4,#20H			;se nacte novy parametr do R4 (20h) a provede se opet rutina.Po uplynuti teto
	SJMP pokr_91			;zkracene smycky se opet provede,t.j. provadi se rychleji.Po uvolneni tlacitka se nuluje priznak zpomal_bit.Pri dalsim vstupu do rutiny
					;se casovani opakuje (pri trvalem stisku TL jedna pomala a ostatni rychle(po dobu stisku)
;-----------------------------Vlasni rutina UP--------
pokr_63:MOV R4,#0FFH
pokr_91:SETB zpomal_0			;nuluj priznak casovaci smycky
	MOV schov_3,A			;uschovej dis nebo dis+1
	MOV A,nast			;nacti parametr nastaveni (pricitane cislo)
	CJNE A,#22H,pokr_76		;pokud jde o dvt,proved pricteni parametru bez DA
	MOV A,schov_3
	ADD A,nast
	SJMP pokr_77
pokr_76:MOV A,schov_3
	ADD A,nast
	DA A
pokr_77:CJNE A,pretec_up,pokr_109	;pokud nedoslo k preteceni pokracuj
	MOV A,nast			;doslo-nacti pricitane cislo
	CJNE A,#22H,pokr_78		;pokud jde o dvt
	MOV A,#01H			;nacti po preteceni hodnotu 01
	SJMP pokr_109		
pokr_78:CLR A				;jinak nacti 0
	SJMP pokr_109


;------------------Rutina DOWN-------------------------
pokr_115:CLR down_bit			;nuluj priznak

;-------------zpozdeni--------
	JNB zpomal_1,pokr_62
	DJNZ R4,pokr_109		;popis funkce viz vyse
	MOV R4,#20H
	SJMP pokr_92
;---------------------------Vlasni rutina DOWN---------------
;rutina down pracuje tak ze odecita od katod 1 a kdyz dojde k podteceni na FFh
;nacte aktualni data tabulky preteceni,snizi je o jednu(viz tabulka) a ulozi do katod

pokr_62:MOV R4,#0FFH
pokr_92:SETB zpomal_1			;nastav priznak zpomalovaci smycky
	MOV schov_3,A
	MOV A,nast			;nacti pricitane cislo
	CJNE A,#22H,pokr_80		;pokud nejde o dvt,pokracuj	
	MOV A,schov_3			;jinak proved hexa odecet parametru
	SUBB A,#22H
	JNC pokr_109			;pokud doslo k podteceni,nacti data
	MOV A,pretec_down
	SJMP pokr_109

;-----BCD odecet-------
pokr_80:MOV R6,nast			;neslo o dvt,proved odecet BCD,do R6 parametr
	CLR C				;nuluj CARRY
	MOV A,#99H			;nacti zaklad dec. doplnku
	SUBB A,R6			;odecti nast
	ADD A,#1H			;pricti jednicku - pro dekadicky zaklad 100
	DA A				;dek. korekce
	MOV R6,A			;uloz dek. doplnek cisla "nast"
	CLR A				;nuluj ACC ale ne CARRY
	ADDC A,R6			;secti obsah 
	DA A				;korekce
	MOV R6,A			;uloz zpet-toto je pro pripad preteceni(pricteni CY)
	MOV A,schov_3			;proved pricteni doplnku t.j. odecet
	ADD A,R6
	DA A				;pri platnem vysledku je nastaven CY
	JC pokr_109			;pokud neni vysledek zaporny,pokracuj
	MOV schov_3,A			;uloz vysledek
	MOV A,nast			;nacti parametr
	CJNE A,#10H,pokr_82		;pokud je editovana cifra vyssi nibble,nacti zpet editovane cislo
	MOV A,schov_3			;(plati pro spotrebu)
	SJMP pokr_109			;a pokracuj
pokr_82:MOV A,pretec_down		;jinak nacti preteceni
pokr_109:JB submenu_bit,pokr_110	;pokud nejsem v submenu
	JNB jednicky,pokr_21		;a needituji jednicky
	SETB blik_bit3			;nastav pozadavky blikani
	SETB blik_bit1			;blikej jednickami
	CLR blik_bit4
	CLR blik_bit2
	MOV R0,#schov_1			;do R0 adresu schov_1
	MOV @R0,A			;uschovej ACC
	MOV A,schov_2			;do A cislo z dis(dis+1) pred editaci
	XCHD A,@R0			;prohod nizsi nibble mezi cisly pred a po editu
	SJMP pokr_20
pokr_21:SETB blik_bit4			;blikej desitkami
	SETB blik_bit2
	CLR blik_bit3
	CLR blik_bit1
pokr_20:JNB obeh_bit,pokr_112		;pokud neni obeh jde o dis
	MOV dis+1,A			;uloz editovanou hodnotu
	CLR blik_bit4			;a blikej s dis+1
	CLR blik_bit3
	MOV A,fce			;nacti fci
	CJNE A,#1H,pokr_24		;pokud jde o realtime
	SETB blik_bit1		
	SETB blik_bit2
	SJMP pokr_24
pokr_110:MOV dis+1,A			;jsem v submenu,uloz do dis+1
	SETB blik_bit2			;nastav blikani pro dis+1
	SETB blik_bit1
	SJMP pokr_24
pokr_112:MOV dis,A			;uloz do dis
	CLR blik_bit2			;blikej s dis
	CLR blik_bit1
	MOV A,fce			;nacti fci
	CJNE A,#1H,pokr_24		;pokud jde o realtime pokracuj
	SETB blik_bit4			;jinak nastav blikani dis
	SETB blik_bit3
pokr_24:MOV A,anody		
	XRL A,#1H    			;je aktivovan posledni displej ?        
	JZ pokr_88			;ano-zacni znovu
	LJMP pokr_03			;skok na zacatek
pokr_88:LJMP zac

;---------Rutina provozniho casu-------
rtc:	PUSH ACC			;uloz ACC A PSW	
	PUSH PSW
	MOV mezi_1,R0			;schovej R0
	JNB P1.2,pokr_85		;testuj stav CS_RTC (aktivni L)
	SETB cs_rtc			;neni,nastav priznak aktivace CS_RTC
	CLR P1.2 			;aktivuj CS_RTC
pokr_85:MOV R0,#0FDH			;testuj vektor preruseni
	MOVX A,@R0
	JB ACC.2,pokr_38 		;pokud je aktivni z RTC,proved obsluznou rutinu
	JNB cs_rtc,pokr_95		;byl RTC aktivovan v tomto INT ?
	CLR cs_rtc			;ano=nuluj flag 
	SETB P1.2			;deaktivuj RTC
pokr_95:LJMP prerus_01			;proved obsluhu vnejsiho INT0
pokr_38:MOV R0,#0FDH			;nuluj priznak preruseni v RTC
	CLR A	
	MOVX @R0,A
	INC R3				;soft citac volani INT od RTC (Fint=64 Hz)
	CJNE R3,#07H,pokr_15		;test pro blikani 
	CPL blik_bit0			;blikej
pokr_15:CJNE R3,#40H,out_02		;po dosazeni poctu volani pro 1s proved rutinu
	MOV R3,#0H			;nuluj citac
	CPL blik_bit0			;invertuj blik_bit (pro nesoumerne blikani)
	JNB P1.1,out_02			;test pozadavku chodu provozniho casu
	JB err_bit,out_02		;test bitu err_bit ->je-li nastaven vystup z rutiny=hodiny nenacitaji
	MOV A,vt_prov			;nacti do ACC byte vteriny provozniho casu
	ADD A,#1H			;pricti 1
	MOV vt_prov,A			;uloz vteriny zpet
	XRL A,#3CH			;je dosazeno minuty ?	
	JNZ out_02			;neni pak navrat z preruseni
	MOV vt_prov,A			;nuluj byte vteriny
	MOV A,min_prov			;nacti do ACC obsah byte minuty
	ADD A,#1			;pricti k ACC 1
	MOV min_prov,A			;uloz minuty zpet
	XRL A,#3CH			;je dosazeno hodiny ?
	JNZ out_02			;neni pak navrat z preruseni
	MOV min_prov,A			;nuluj byte minuty
	MOV A,hod_prov			;nacti do ACC obsah byte hodiny
	ADD A,#1			;pricti k ACC 1
	MOV hod_prov,A			;uloz zpet hodiny
	CJNE A,#64H,pokr_100		;je dosazeno 100 hodin ? (nebo po zapnuti napajeni libovolne vetsi cislo)
pokr_100:JC out_02			;neni pak navrat z preruseni
	SETB err_bit			;je dosazeno 99 hodin -> pak nastav err_bit
out_02:	JNB cs_rtc,pokr_86		;byl RTC aktivovan v tomto INT ?
	CLR cs_rtc			;ano=nuluj flag 
	SETB P1.2			;deaktivuj RTC
pokr_86:MOV R0,mezi_1			;obnov R0
	POP PSW				;obnov stavove slovo
	POP ACC				;obnov ACC
	RETI				;navrat z INT


;--------------Subrutina nezobrazeni bezvyznamnych nul-------------------------------------------------------
;Obsluhuje zobrazovani nul na displeji takto:Realny cas,provozni cas,drahu okamzitou a prumernou spotrebu a zustatek paliva zobrazuje takto:
;pokud jsou same nuly,pak je zobrazi.Pokud je jakakoliv cifra ruzna od nuly a prvni cifra je nula,prvni cifra zustane zhasnuta.(dosazeno 0EH0)	
;Pro zobrazeni udaju 000.0 funguje stejne s prvni cifrou.O druhou cifru se stara rutina nuly_1,ktera
;zajisti,ze pri druhe cifre=0 je take nezobrazena (vysledek 0.0) t.zn. ze pro funkce se zobrazenim 000.0 se rutiny nuly a nuly_1 kombinuji


nuly:	JB edit,pokr_12			;pokud jsi v editaci,neprovadej nic (kvuli nastavovani zustatku paliva,aby pri editaci svitili vsechny cifry i bezvyznamna nula)
	MOV A,fce
	CJNE A,#1,pokr_119
	SJMP pokr_12
pokr_119:MOV A,dis+1			;pokud nebude dis+1 zobrazovat nuly,pokracuj normalnim testem 1. nuly na displeji
	JNZ pokr_120			; a jejim pripadnym potlacenim
	MOV A,dis			;pokud bude zobrazovat nuly,testuj obsah dis.Pokud bude i ten zobrazovat nuly,ponech beze zmeny
	JZ pokr_12			;jinak proved test nuly na prvni pozici
pokr_120:MOV A,anody			;nacti anody
	CJNE A,#08H,pokr_12		;pokud budes zobrazovat prvni cifru...
	MOV A,katody
	JNZ pokr_12			;a jeji obsah je nula-pak zobraz "prazdny znak"
	MOV A,#0EH			;zobraz "prazdny znak"
	MOV katody,A
pokr_12:RET



;-----------------Rutina nuly_1 pro osetreni bezvyznamnych nul u udaju s des.teckou na treti pozici 000.0------
nuly_1:	MOV A,dis+1			;nacti dis+1
	JNZ pokr_122			;pokud neni 00,skok na testovani dis
	MOV A,dis			;pokud je nula,otestuj dis
	JZ pokr_121			;pokud je dis=0 (t.j. dis a dis+1 = 00 00) navrat a zobrazuj 000.0
pokr_122:MOV A,dis			;pokud neni dis+1=0 a dis je =0,dosad do dis 0EH tzn. ze by svitilo
	JNZ pokr_121			;0_0.0 ,ale o prvni nulu se postara rutina nuly
	MOV dis,#0EH	
pokr_121:RET




;--------Subrutina provozniho casu-------------------
;tato rutina zajistuje zobrazeni provozniho casu na displej,vynulovani prov. casu a pri preteceni zobrazeni zpravy ERRor na displej
p_time:	MOV DPTR,#tabznak
	JNB nul_bit,pokr_29		;pokud neni pozadavek nulovani,skok
	CLR nul_bit			;je pozadavek nulovani
	MOV vt_prov,#0			;nuluj byte provoznich vterin
	MOV min_prov,#0			;--//---    prov. minut
	MOV hod_prov,#0			;--//---    prov. hodin
	CLR err_bit			;nuluj bit ERR
pokr_29:JNB err_bit,pokr_28		;test bitu ERR ->je-li nastaven pokracuj na rutinu copy p_timu do dis		
	MOV tecka,#0H			;zhasni tecku
	MOV DPTR,#tabpisma		;pri nastaveni ERR do DPTR adresu tabulky pisma
	MOV dis,#01H			;uloz do dis a dis+1 direktivne adresy znaku E,r,r z tabulky tabpisma
	MOV dis+1,#23H
	SJMP out_03			;navrat z rutiny
pokr_28:LCALL hod			;volani rutiny zobrazeni prov. timu (min+vt nebo hod+min)
out_03:	LJMP pokr_99

;------------Subrutina hodiny---------dle obsahu hod,min,vter,zobrazuje na 
;displej hodiny+minuty nebo minuty+vteriny provozniho casu

hod:	JNB P1.1,pokr_47		;pokud nebezi prov. time,tecka sviti
	JB blik_bit0,pokr_47		;zablikej teckou
	MOV tecka,#0H
	SJMP pokr_48
pokr_47:MOV tecka,#4H	
pokr_48:MOV hex_1,vt_prov		;nacti vteriny pro prevod
	MOV hex_2,#0H
	MOV hex_3,#0H
	LCALL prevod			;realizuj prevod
	MOV schov_1,bcd_1		;uloz prevedene vteriny
	MOV hex_1,min_prov		;nacti minuty pro prevod
	LCALL prevod			;realizuj prevod
	MOV schov_2,bcd_1		;uloz prevedene minuty
	MOV hex_1,hod_prov		;nacti hodiny pro prevod
	LCALL prevod			;realizuj prevod
	MOV schov_3,bcd_1		;uloz prevedene hodiny
	MOV A,schov_3			;nacti hodiny
	JZ pokr_08 			;pokud nejsou hodiny=0 pak posli do dis a dis_1 hodiny a minuty
	MOV dis,schov_3
	MOV dis+1,schov_2
	SJMP pokr_07
pokr_08:MOV dis,schov_2			;pokud jsou hodiny=0 pak posli do dis a dis_1 minuty a vteriny
	MOV dis+1,schov_1
pokr_07:RET

;---------------Subrutina mereni okamzite rychlosti----------

;tato rutina zmeri periodu impulsu na vstupu INT0 a vysledek ulozi ve tvaru: vysl_1 -->nizsi byte
;vysl_2 -->vyssi byte,cit_kmh -->3 pseudobyte hardware citace (zaveden softwarove) 

prerus_01:SETB P3.4			;vyrob nulovaci puls pro vstupni latch registr preruseni
	CLR P3.4
	CPL pom1_bit
	JNB pom1_bit,pokr_124
	JB int_bit,pokr_35		;je-li bit int_bit nastaven jde o druhe mereni-skok na vypocet
	MOV cit_kmh,#0			;prvni mereni-vynuluj software citac
	MOV TH0,#0H
	MOV TL0,#0
	SETB TR0			;spust citac
	SETB int_bit			;nastav bit indikujici stav merici rutiny
	SJMP out_04			;vystup z INT
pokr_35:CLR int_bit			;druhe mereni-nuluj bit indikujici stav merici rutiny
	MOV vysl_3,cit_kmh
	MOV vysl_2,TH0
	MOV vysl_1,TL0

;----------------------------------------------------------------------------
;Rutina zaznamenani ujete drahy-do 9999 km,pak se nuluje
;pracuje v hexa-> na zobrazeni nutno prevest do bcd
out_04:MOV A,drh_1			;nacti nejnizsi byte citace (jed. metru)
	ADD A,#1H			;pricti 1
	MOV drh_1,A			;uloz vysledek
	MOV A,drh_2			;nacti 2.byte
	ADDC A,#0H			;pricti CY (resp.0H)
	MOV drh_2,A			;uloz vysledek
	MOV A,drh_3			;opakuj pro 3.byte
	ADDC A,#0H
	MOV drh_3,A
	MOV A,drh_1			;nacti nejnizsi byte pro kontrolu preteceni celeho citace
	CJNE A,#80H,out_05		;preteceni na 00:00:00 po dosazeni 10000000m tj.10 000km tj. 989680H,pokud neni roven preteceni->vystup
	MOV A,drh_2			;pokud je nejnizsi byte roven predvolbe preteceni,nacti prostredni byte pro dalsi kontrolu
	CJNE A,#96H,out_05		;pokud neni roven predvolbe->vystup,jinak pokracuj dalsim testem 
	MOV A,drh_3
	CJNE A,#98H,out_05
	MOV drh_1,#0H			;pokud je splneno preteceni celeho citace drahy,nuluj citac
	MOV drh_2,#0H
	MOV drh_3,#0H
out_05:	JNB cs_rtc,pokr_87
	CLR cs_rtc
	SETB P1.2
pokr_87:MOV R0,mezi_1
pokr_124:POP PSW				;navrat z INT
	POP ACC
	RETI	
;-----------------------------------------------------------
cit:	PUSH ACC
	PUSH PSW
	MOV A,cit_kmh			;nacti software citac
	ADD A,#1H			;pricti jednicku...
	MOV cit_kmh,A			;a uloz
	XRL A,#19H			;testuj dosazeni software citace 1,6384 s(t.j. zastaveni)
	JNZ pokr_36			;pokud nedosahl vystup
	MOV vysl_1,#0H			;pokud dosahl,nuluj okamzitou rychlost
	MOV vysl_2,#0H
	MOV vysl_3,#0H
	CLR TR0				;zastav citac
	SETB nul_draha			;priznak indikujici ze vozidlo stoji (nulovy cas drahy)
	SJMP out_07			;pro prepnuti okamzite spotreby na motohodiny
pokr_36:CLR nul_draha
out_07:	POP PSW
	POP ACC
	RETI


;-------------Rutina kmh-vypocet okamzite rychlosti-------
;podle rovnice 36000000/delka impulsu drahy
kmh:	MOV tecka,#2H			;rozsvit trvale tecku u 3. cislovky zleva (1 desetinne misto)
	MOV vys,#02H			;zadej parametry pro deleni (36 000 000D, t.j.02 25 51 00H)
	MOV str,#25H
	MOV niz,#51H
	MOV nejniz,#00H
	MOV vys_1,vysl_3		;parametr druheho cisla pro deleni (delka impulsu v ms tribytove)
	MOV str_1,vysl_2
	MOV niz_1,vysl_1
	LCALL deleni			;proved deleni
	MOV hex_1,nejniz		;zadej parametry pro prevod HEX -> BCD
	MOV hex_2,niz
	MOV hex_3,str
	LCALL prevod			;proved prevod
	MOV dis,bcd_2
	MOV dis+1,bcd_1
	LCALL nuly_1			;volani omezeni bezvyznamnych nul c.1
	LJMP pokr_99			;navrat


;---------------------------------------------------------------------
;Rutina "nasob" vynasobi 3 byte (nizsi nasob_1 a stredni nasob_2 a vyssi nasob_3 bytem nasob_4
;a vysledek ulozi do bytu nasob_5,nasob_6,nasob_7 a nasob_8

nasob:	MOV A,nasob_4			;nacti do ACC byte nasobeni
	MOV B,nasob_1			;nacti do B nizsi cast nasobeneho cisla
	MUL AB				;vynasob cisla
	MOV nasob_5,A			;nizsi cast vysledku do nasob_4
	MOV nasob_6,B			;vyssi cast vysledku do nasob_5
	MOV A,nasob_4			;nacti znovu prvni nasobici cislo
	MOV B,nasob_2			;nacti do B stredni cast nasobeneho cisla
	MUL AB				;vynasob cisla
	ADD A,nasob_6			;secti nizsi byte 2. nasobeni a vyssi byte 1.nasobeni
	MOV nasob_6,A
	MOV A,B				;vezmi vyssi byte 2.nasobeni a vloz do ACC
	ADDC A,#0H			;pricti CY	
	MOV nasob_7,A			;uloz vysledek do stredniho bytu
	MOV A,nasob_4			;nacti opet nasobici byte
	MOV B,nasob_3			;nacti nejvyssi byte nasobeny
	MUL AB				;vynasob cisla
	ADD A,nasob_7			;secti nizsi cast vysledku 3. nasobeni a vyssi cast vysledku 2. nasobeni
	MOV nasob_7,A		
	MOV A,B				;vezmi vyssi cast vysledku 3. nasobeni
	ADDC A,#0H			;pricti CY
	MOV nasob_8,A			;uloz
	RET


;--------------------Subrutina deleni 4 bytoveho cisla 3 bytovym-----
;Rutina vydeli 4 bytove cislo ulozene v bytech vys=nejvyssi byte,str=stredni byte,niz=nizsi byte a nejniz=nejnizsi byte
;3 bytovym cislem ulozenym v bytech vys_1=vyssi,str_1=stredni a niz_1=nizsi
;vysledek je v bytech nejniz,niz,ev.str,+zbytek vys,nejvys


deleni:	MOV vvys,#0H			;nuluj pomocny byte delence
	MOV A,vys_1			;nacti vyssi byte delitele
	JNZ pokr_37			;pokud je nulovy,testuj ....
	MOV A,str_1			;obsah stredniho bytu na nulovost - pokud neni nula,zadej po skoku parametry deleni
	JNZ pokr_37			;pokud je nulovy,testuj nejnizsi byte na nulovost
	MOV A,niz_1
	JNZ pokr_39			;pokud je i tento byte nulovy nuluj cely vysledek a odchod z rutimy
	MOV nejniz,#0H			;pokud neni nula,zadej nove parametry deleni
	MOV niz,#0H
	MOV str,#0H
	RET


;parametry deleni 3 (resp. 1bytovym) cislem (pr. 00 00 0AH) pocet posuvu je 3*8 byte
;a je treba prohodit byty niz_1 a str_1 (str_1 = 00H)

pokr_39:MOV pocpos,#18H			;zadej pocet posuvu	
	MOV str_1,niz_1
	MOV niz_1,#0H
	SJMP znovu

;parametry deleni 3 (resp. 3 a 2bytovym) cislem (pr. 22 22 22H,00 22 22H) pocet posuvu je 
;2*8 byte,pozice zustavaji stejne,nastaven bit pro vynulovani nejvyssiho bytu vysledku(str)
;kde se nachazel zbytek

pokr_37:MOV pocpos,#10H
	SETB uprav_bit
znovu:	CLR C				;nuluj CY pred rotaci
	LCALL rot			;rotuj 3 byte a vynuluj nejnizsi
	LCALL uloz			;pred odectem uloz vysledek rotace
	CLR C				;nuluj CY pred odectem
	LCALL odecet			;odecti od byte vys,str,niz byte vys_1,niz_1
	JNC pokr_30			;pokud neni CY skoc
	LCALL zpet			;pokud je CY pak vrat obsah do stavu pred odectem
test_10:DJNZ pocpos,znovu		;sniz pocet posuvu a zacni znovu
	SJMP test_11			;pokud byl plny pocet obehu skonci
pokr_30:MOV A,nejniz
	INC A
	MOV nejniz,A
	SJMP test_10			;skok na test posuvu
test_11:JNB uprav_bit,konec
	MOV str,#0H
konec:	RET

;------------------Rutiny----------------------------------


;Rutina  "uloz" - uschova vys_1,str_1 a niz_1 do schov_1,schov_2 a schov_3

uloz:	MOV schov_1,vvys
	MOV schov_2,vys
	MOV schov_3,str
	MOV schov_4,niz
	MOV schov_5,nejniz
	RET
;----------------------------------------------------------

;Rutina "rot" - rotuje pres CY 4 byte
rot:	MOV A,nejniz
	RLC A
	MOV nejniz,A
	MOV A,niz			;nacti obsah niz
	RLC A				;rotuj doleva niz pres CY
	MOV niz,A			;uloz vysledek
	MOV A,str			;nacti str
	RLC A				;rotuj A
	MOV str,A			;uloz vysledek
	MOV A,vys			;nacti vys
	RLC A				;rotuj A
	MOV vys,A			;uloz vysledek
	MOV A,vvys
	RLC A
	MOV vvys,A
	RET


;----------------------------------------------------------

;Rutina "zpet" - opak rutiny uloz

zpet:	MOV vvys,schov_1
	MOV vys,schov_2
	MOV str,schov_3
	MOV niz,schov_4
	MOV nejniz,schov_5	
	RET
;----------------------------------------------------------

;Rutina hexadec. odecitani 3 byte cisla -----

odecet:	MOV A,str
	SUBB A,niz_1
	MOV str,A
	MOV A,vys			;nacti vyssi byte delence
	SUBB A,str_1			;odecti od nej stredni byte delitele
	MOV vys,A			;uloz vysledek
	MOV A,vvys			;nacti nejvyssi byte delence
	SUBB A,vys_1			;odecti od nej vyssi byte delitele
	MOV vvys,A			;uloz vysledek	
	RET
;-----------------------------------------------------------


;------------------Rutina prevodu 3bytoveho cisla v hexa na 2 bytove cislo v bcd formatu
;tato rutina prevede HEXA 3bytove cislo ulozene v bytech hex_1(nejnizsi),hex_2,hex_3(nejvyssi) na cislo BCD ulozene v bytech BCD_1(nejnizsi)
;BCD_2,BCD_3(nejvyssi)

prevod:	MOV vahy_1,#1H			;nacti do nejnizsiho bytu vah nejnizsi vahu t.j. cislo 1
	MOV vahy_2,#0H			;nuluj vyssi vahy
	MOV vahy_3,#0H			;nuluj vyssi vahy
	MOV bcd_1,#0H			;nuluj byty pro vysledek prevodu
	MOV bcd_2,#0H
	MOV bcd_3,#0H
	MOV pocpos_01,#18H		;zadej pocet provedeni prevodu (pro 3 byte=24x)
pokr_31:CLR C	
	MOV A,hex_3			;rotuj 3 byte s hexa cislem doprava a zjisti zda je nejnizsi byte 1 nebo 0
	RRC A
	MOV hex_3,A
	MOV A,hex_2
	RRC A
	MOV hex_2,A
	MOV A,hex_1
	RRC A
	MOV hex_1,A
	JNC pokr_32			;pokud je roven 0,skoc na zvyseni vah	
	MOV A,bcd_1			;pokud je roven 1,pricti aktualni vahy k vysledku a proved DA (3 bytove)
	ADD A,vahy_1
	DA A
	MOV bcd_1,A
	MOV A,bcd_2
	ADDC A,vahy_2
	DA A
	MOV bcd_2,A
	MOV A,bcd_3
	ADDC A,vahy_3
	DA A
	MOV bcd_3,A
pokr_32:MOV A,vahy_1			;zvyseni vah:nacti nejnizsi vahy
	ADD A,ACC			;proved secteni vahy sama se sebou (napr. puvodni vaha=2,2+2=4 t.j. dalsi vaha)
	DA A				;proved korekci
	MOV vahy_1,A			;uloz vysledek
	MOV A,vahy_2
	ADDC A,ACC
	DA A
	MOV vahy_2,A
	MOV A,vahy_3
	ADDC A,ACC
	DA A
	MOV vahy_3,A
	DJNZ pocpos_01,pokr_31		;testuj pocet provedeni rutiny,pri nerovnosti skoc na opakovani
	RET

;------------Subrutina "draha" provadi mereni drahy (3 bytove) do 10 000 km-detailnejsi popis viz preruseni 
;take uklada spravne udaje do dis a dis+1 - jakekoliv manipulace v teto rutine s byty bcd_1 az 3 nemodifikuji jejich obsah !!

draha:	MOV DPTR,#tabznak
	JNB nul_bit,pokr_84
	CLR nul_bit
	MOV drh_1,#0H
	MOV drh_2,#0H
	MOV drh_3,#0H
pokr_84:MOV tecka,#4H			;nastav polohu des. tecky
	MOV nejniz,drh_1		;nacti drahu pro deleni
	MOV niz,drh_2
	MOV str,drh_3
	MOV vys,#00H			;proved vydeleni 10 pro ziskani spravneho udaje
	MOV niz_1,#0AH
	MOV str_1,#00H
	MOV vys_1,#00H
	LCALL deleni
	MOV hex_1,nejniz		;zadej parametry prevodu HEXA->BCD
	MOV hex_2,niz	
	MOV hex_3,str
	LCALL prevod			;realizuj prevod
	MOV A,bcd_3			;nacti nejvyssi byte (stovky a tisice km)
	JNZ pokr_11			;je-li 0 .....
	MOV dis,bcd_2			;zobrazuj na displeji desitky.stovky,tisice a desetitisice m (01.15 km) 
	MOV dis+1,bcd_1
pokr_123:LJMP pokr_99

;tato cast slouzi pro bytove presuny z duvodu zobrazeni stovek metru pri zobrazeni do 1000 km(pr. bcd_3=05 bcd_2=63 bcd_1=50 t.j. 
;56350=563.5 km
 
pokr_11:MOV A,bcd_3			;zjisti vymaskovanim,zda je vyssi nibble nulovy
	ANL A,#0F0H			;(05H * 0F0H=00H)
	JNZ pokr_33			;pokud je 0 ...
	MOV A,bcd_2			;nacti bcd_2 (05 `63` 50)
	SWAP A				;proved swap (05 `36` 50)
	MOV dis+1,A			;uloz ACC do nizsiho displeje
	MOV A,bcd_3			;nacti bcd_3 (`05` 36 50)
	SWAP A				;proved swap (`50` 36 50)
	MOV R0,#dis+1			;do R0 adresu dis+1
	XCHD A,@R0			;vymen nizsi nibble ACC <-> adr. R0 (A=56 @R0=30)
	MOV dis,A			;uloz ACC do dis (56)
	MOV A,bcd_1			;nacti do ACC bcd_1 (56 30 `50`)
	SWAP A				;proved swap (56 30 `05`)
	XCHD A,@R0			;vymen nizsi nibble ACC <-> adr.R0 (A=00 @R0=35)
	MOV dis+1,@R0			;uloz vysledek do dis+1 (35)
	MOV tecka,#2H			;nastav polohu des. tecky (563.5 km)
	SJMP pokr_123			;navrat
pokr_33:MOV tecka,#0H			;zhasni des. tecku
	MOV dis,bcd_3			;nacti do dis tisice a stovky km
	MOV dis+1,bcd_2			;a do dis+1 desitky a jednotky km
	SJMP pokr_123			;navrat

;---------------Subrutina p_kmh vypocita prumernou rychlost na zaklade ujete drahy za provozni cas
;resi se na zaklade rovnice 36*(draha v metrech)/cas ve vterinach=prum. rychlost za hodinu
;pro prevod hodin na vteriny se nasobi hod_prov*60 a vysledek znovu *60,protoze je treba
;nasobit hod_prov*3600,ale uzita rutina nasobeni umi nasobit pouze jednobytovym cislem
p_kmh:	MOV tecka,#2H			;rozsvit des. tecku u odpovidajiciho disleje
	MOV nasob_1,drh_1		;nacti data pro nasobeni drahy
	MOV nasob_2,drh_2
	MOV nasob_3,drh_3
	MOV nasob_4,#24H
	LCALL nasob			;proved subrutinu nasobeni
	MOV vys,#00H			;uloz vysledek do promennych pro deleni
	MOV str,nasob_7
	MOV niz,nasob_6
	MOV nejniz,nasob_5
	MOV schov_1,#0H			;resetuj univerzalni promenne	
	MOV schov_2,#0H
	MOV schov_3,#0H
;prevod provozniho casu na sekundy
	MOV nasob_1,hod_prov		;nacti hodiny
	MOV nasob_2,#00H
	MOV nasob_3,#00H
	MOV nasob_4,#3CH		;a nasob 60D
	LCALL nasob
	MOV nasob_1,nasob_5		;pro druhe nasobeni nacti vysledek prvni operace
	MOV nasob_2,nasob_6
	MOV nasob_3,nasob_7
	LCALL sek			;proved vynasobeni a uloz data pro soucet
	MOV nasob_1,min_prov		;vynasob minuty 60
	MOV nasob_2,#0H
	MOV nasob_3,#0H
	LCALL sek			;a vysledek secti s vterinami po prevodu hodin
	MOV nasob_5,vt_prov		;nacti vteriny_prov
	MOV nasob_6,#0H
	MOV nasob_7,#0H
	LCALL secti			;a pricti je k prevedenym minutam a hodinam na vteriny
	MOV niz_1,schov_1		;nacti vysledek prevodu do promennych pro deleni
	MOV str_1,schov_2
	MOV vys_1,schov_3
	MOV A,niz_1			;testuj nizsi byt provozniho casu (nyni uz v sec.)
	JNZ pokr_34			;a pokud je =0,testuj dalsi
	MOV A,str_1
	JNZ pokr_34
	MOV A,vys_1
	JNZ pokr_34
	MOV dis,#0H			;pokud jsou vsechny 3 byty=0,pak zobrazuj na disp. 0000
	MOV dis+1,#0H
	LJMP pokr_99
pokr_34:LCALL deleni			;po naplneni vstupnich promennych proved vypocet
	MOV hex_1,nejniz		;vysledek uloz do promennych pro prevod HEX->BCD
	MOV hex_2,niz
	LCALL prevod			;preved na BCD
	MOV dis,bcd_2			;uloz do promennych displeje
	MOV dis+1,bcd_1
	LCALL nuly_1
	LJMP pokr_99
sek:	LCALL nasob			;proved vynasobeni
secti:	CLR C
	MOV A,schov_1			;rutina prubezneho souctu pri prevadeni hodin a minut na sekundy
	ADD A,nasob_5
	MOV schov_1,A
	MOV A,schov_2
	ADDC A,nasob_6
	MOV schov_2,A
	MOV A,schov_3
	ADDC A,nasob_7
	MOV schov_3,A
	RET

;-------------Subrutina realneho casu-------
;provadi vycitani RTC
real:	LCALL wait
	CLR P1.2			;aktivace RTC
	JNB obeh_bit,pokr_113		;dosazuje do preteceni hodnoty dle displeje
	MOV pretec_up,#60H		;minuty-po dosazeni 60 nuluj
	MOV pretec_down,#59H		;minuty-po dosazeni nuly zadej 59
	SJMP pokr_114
pokr_113:MOV pretec_up,#24H		;hodiny-po dosazeni 24 nuluj
	MOV pretec_down,#23H		;hodiny-po dosazeni nuly zadej 23
pokr_114:MOV DPTR,#tabznak		;vrat do DPTR zobrazovani znaku
	JB edit,out_09			;pokud jsi v editu preskoc rutinu
	JNB nul_bit,pokr_72
	CLR nul_bit			;pokud je pozadavek vstupu do submenu,nastav shift_bit
	SETB shift_bit
pokr_72:JNB blik_bit0,pokr_45		;zablikej teckou po 1 vterine 
	MOV tecka,#4H
	SJMP pokr_46
pokr_45:MOV tecka,#0H	
pokr_46:MOV R0,#0F5H			;nacti desitky hodin
	MOVX A,@R0	
	ANL A,#0FH			;vymaskuj je
	SWAP A				;prehod a zapis do byte hodiny
	MOV hodiny,A
	DEC R0				;sniz adresu na jednotky hodin
	MOVX A,@R0			
	ANL A,#0FH			;nacti je a vymaskuj
	ADD A,hodiny			;a pricti k nim desitky
	MOV dis,A			;uloz do dis
	DEC R0				;sniz adresu na desitky minut
	MOVX A,@R0			;nacti data
	ANL A,#0FH			;vymaskuj
	SWAP A				;prehod a zapis do bytu minut
	MOV minuty,A
	DEC R0				;sniz adresu na jednotky minut
	MOVX A,@R0			;nacti data
	ANL A,#0FH			;proved vymaskovani
	ADD A,minuty			;a pricti k nim desitky minut
	MOV minuty,A			
	MOV dis+1,minuty		;uloz do dis+1
out_09:SETB P1.2			;deaktivace RTC
	LJMP pokr_99

;--------Rutina obsluhy preruseni od citace 01-------
;po preteceni dvou byte hardware citace je inkrementovan software citac
;a nadale je opet osetreno (jako u drahy)vynulovani,pokud neprijde impuls od snimace paliva  
;do 1,966s(oproti draze prodlouzeno)
cit_01:	PUSH ACC
	PUSH PSW
	INC cit_pal0			;inkrementuj software citac
	MOV A,cit_pal0			;a uloz
	XRL A,#1EH			;testuj dosazeni software citace 1,966 s
	JNZ pokr_57			;pokud nedosahl vystup
	MOV vysl_10,#0H			;pokud dosahl,nuluj okamzitou rychlost
	MOV vysl_20,#0H
	MOV vysl_30,#0H
	CLR TR1				;a zastav hardware citac
pokr_57:POP PSW			
	POP ACC
	RETI				;navrat
	

;--------Rutina obsluhy externiho preruseni 01-------
;tato rutina zmeri periodu impulsu na vstupu INT1 a vysledek ulozi ve tvaru: vysl_10 -->nizsi byte
;vysl_20 -->vyssi byte

int_01:	PUSH ACC
	PUSH PSW
	SETB P3.5			;vyrob nulovaci puls pro vstupni latch registr preruseni
	CLR P3.5
	JB int1_bit,pokr_40		;je-li bit int1_bit nastaven jde o druhe mereni-skok na vypocet
	MOV TH1,#0H			;jde o prvni mereni-nuluj hardware citac								
	MOV TL1,#0H
	MOV cit_pal0,#0H
	SETB TR1			;spust casovac
	SETB int1_bit			;nastav bit indikujici stav merici rutiny
	SJMP pokr_49			;pokracuj na pocitadlo benzinu
pokr_40:CLR int1_bit			;druhe mereni-nuluj bit indikujici stav merici rutiny
	MOV vysl_30,cit_pal0		;uloz vyslednou delku impulsu od snimace paliva
	MOV vysl_20,TH1
	MOV vysl_10,TL1
pokr_49:MOV A,cit_pal10			;inkrementuj citac paliva (tento citac pocita 
	ADD A,#1H			;impulsy od pocatku jizdy pro potreby vypoctu prumerne spotreby) 
	MOV cit_pal10,A
	MOV A,cit_pal20
	ADDC A,#0H
	MOV cit_pal20,A
	MOV A,cit_pal30
	ADDC A,#0H
	MOV cit_pal30,A

;tento citac paliva cita vstupni impulsy od snimace paliva a pri dosazeni 150 impulsu
;(t.j. 0,01 litru) se nuluje,pocita od nuly a dekrementuje se hlavni citac paliva t.j. ;palivo se odecita od zadane hodnoty
	MOV A,cit_pal3			;pri dosazeni nuloveho stavu zastav odecitani
	JNZ pokr_50			;a nuluj citac 150 impulsu
	MOV A,cit_pal2
	JNZ pokr_50
	MOV cit_pal1,#0H
	SJMP out_06			;a vystup z INT			
pokr_50:INC cit_pal1			;zvys o jednu citac 150 impulsu
	MOV A,cit_pal1
	XRL A,#96H			;porovnej citac s cislem 150
	JNZ out_06			;nedosazeno 150,vystup z preruseni
	MOV cit_pal1,A			;dosazeno 150,nuluj citac
	MOV A,cit_pal2			;nacti nizsi byte citace paliva
	CLR C				;nuluj carry
	SUBB A,#1H			;odecti jednicku
	MOV cit_pal2,A			;uloz aktualni stav
	JNC pokr_51			;nedoslo k podteceni->pokracuj na test minimalni hladiny paliva
	CLR C
	MOV A,cit_pal3			;nacti vyssi byte citace paliva
	SUBB A,#1H			;odecti jednicku
	MOV cit_pal3,A			;uloz aktualni stav

;-------kontrola minimalniho stavu paliva-momentalne nastaveno na 04.00 l
pokr_51:MOV A,cit_pal3			;nacti vyssi byte citace paliva
	CJNE A,#1H,out_06		;kontrola vyssiho byte citace paliva
	MOV A,cit_pal2			;pri dosazeni nacti nizsi byte paliva
	CJNE A,#90H,out_06		;kontrola nizsiho byte citace paliva
	SETB rezpal_bit			;pri dosazeni rezervy nastav priznak
	CLR shift_bit			;nuluj vyvolani submenu
	LCALL wav_zuspal		;nacti adresaci PCM
	MOV fce,#8H			;a zobraz zustatek na displej
	CLR pom_bit			;nuluj priznak pro puleni dlouhych rutin
	SETB wav2_bit 			;nastav priznak pro vyvolani chodu PCM
out_06:	POP PSW				;navrat
	POP ACC
	RETI


;----------------------------Vypocet okamzite spotreby---------------------
;pocita se podle rovnice 100000000/cas spotreby(mikrosec.)*cas drahy(mikrosec.)/10000*66667/1000000=okamzita spotreba
;u deleni 10000 pred 66667 se provede porovnani vypoctu kvuli tomu, ze pri zobrazeni nad 40l se zobrazuje
;40.0 l a pod 40 se zobrazuje 40.00 l

ok_spot:CPL pom_bit			;rozdeleni rutiny kvuli delce na dve casti
	JB pom_bit,pokr_97		;dle priznaku pom_bit vykonej 1. nebo 2. cast rutiny
	LJMP pokr_98			;skok na 2. cast rutiny
pokr_97:MOV vys,#05H			;nacti delenec (100 000 000)
	MOV str,#0F5H
	MOV niz,#0E1H
	MOV nejniz,#00H
	MOV vys_1,vysl_30		;nacti delitel (cas spotreby v mikrosec.)
	MOV str_1,vysl_20
	MOV niz_1,vysl_10
	LCALL deleni			;volej rutinu deleni
	
;nasobeni 3x3 byte

	MOV nasob_1,nejniz		;nacti vysledek deleni do promennych rutiny nasobeni
	MOV nasob_2,niz
	MOV nasob_3,str
	MOV nasob_4,vysl_1		;nacti nejnizsi cast casu drahy
	JNB nul_draha,pokr_55		;testuj zda vozidlo nestoji
	MOV nasob_4,#0A0H		;pokud ano zadej konstantu pro motohodiny
pokr_55:LCALL nasob			;volej rutinu nasobeni
	MOV schov_1,nasob_5		;uloz vysledek
	MOV schov_2,nasob_6
	MOV schov_3,nasob_7
	MOV schov_4,nasob_8
	MOV nasob_4,vysl_2		;nacti stredni byte casu drahy,obsazeni nasob_1 az nasob_3 zustava nezmeneno
	JNB nul_draha,pokr_56		;opet testuj zda vozidlo nestoji
	MOV nasob_4,#8CH
pokr_56:LCALL nasob
	MOV A,schov_2			;proved pricteni vysledku druheho dilciho nasobeni k prvnimu
	ADD A,nasob_5			;ulozenemu v schov_1 - schov_4 takto: 1.nasob xx xx xx xx 
	MOV schov_2,A			;                	           2.nasob xx xx xx xx	
	MOV A,schov_3			;		                ==         xx xx xx xx xx
	ADDC A,nasob_6												
	MOV schov_3,A
	MOV A,schov_4
	ADDC A,nasob_7
	MOV schov_4,A
	MOV schov_5,nasob_8
	MOV nasob_4,vysl_3		;nacti nejvyssi byte casu drahy		
	LCALL nasob			;pokud vozidlo stoji,je=0(36000=8CA0H t.j. 2 byte) 
	MOV A,schov_3
	ADD A,nasob_5
	MOV schov_3,A
	MOV A,schov_4
	ADDC A,nasob_6
	MOV schov_4,A
	CJNE A,#23H,pokr_52		;proved porovnani s cislem 23C31EF0h
	MOV A,schov_3			;pokud je porovnavane cislo vetsi,
	CJNE A,#0C3H,pokr_52		;del je 100000,jinak 10000
	MOV A,schov_2			;vyse uvedene cislo odpovida zobrazeni
	CJNE A,#1EH,pokr_52		;40.00 litru
	MOV A,schov_1			;porovnani:pokud je A nerovno pokracuj skokem,pricemz
	CJNE A,#0F0H,pokr_52		;kdyz A>data pak CY=0,kdyz A<data pak CY=1
pokr_52:JC pokr_53			;pokud je rovno testuj dalsi (nizsi) byte

;----------------------------proved deleni 10000 nebo 100000 - t.j. vysledek platny na 2 nebo 1 des. misto
	MOV tecka,#2H			;rozsvit tecku na odpovidajici pozici
	MOV niz_1,#0A0H			;nacti delitel (100000)
	MOV str_1,#86H
	MOV vys_1,#01H
	SJMP pokr_54
pokr_53:MOV tecka,#4H			;rozsvit tecku na odpovidajici pozici
	MOV niz_1,#10H			;nacti delitel (10000)
	MOV str_1,#27H
	MOV vys_1,#0H
pokr_54:MOV nejniz,schov_1		;nacti delenec
	MOV niz,schov_2
	MOV str,schov_3
	MOV vys,schov_4
	LCALL deleni			;proved deleni
	LJMP pokr_99

;----------proved vynasobeni 66667D=01046B H
pokr_98:MOV nasob_1,nejniz		;nacti vysledek deleni do promennych rutiny nasobeni
	MOV nasob_2,niz
	MOV nasob_3,str
	MOV nasob_4,#6BH
	LCALL nasob			;volej rutinu nasobeni
	MOV schov_1,nasob_5		;uloz vysledek
	MOV schov_2,nasob_6
	MOV schov_3,nasob_7
	MOV schov_4,nasob_8
	MOV nasob_4,#04H
	LCALL nasob
	MOV A,schov_2			;proved pricteni vysledku druheho dilciho nasobeni k prvnimu
	ADD A,nasob_5			;ulozenemu v schov_1 - schov_4 takto: 1.nasob xx xx xx xx 
	MOV schov_2,A		;			   	   2.nasob xx xx xx xx	
	MOV A,schov_3		;			 	  ==       xx xx xx xx xx
	ADDC A,nasob_6												
	MOV schov_3,A
	MOV A,schov_4
	ADDC A,nasob_7
	MOV schov_4,A
	MOV schov_5,nasob_8
	MOV nasob_4,#01H		
	LCALL nasob		
	MOV A,schov_3
	ADD A,nasob_5
	MOV schov_3,A
	MOV A,schov_4
	ADDC A,nasob_6
	MOV schov_4,A
;------------------------------
;proved deleni 1000000D t.j. 0F4240H
	MOV nejniz,schov_1
	MOV niz,schov_2
	MOV str,schov_3
	MOV vys,schov_4
	MOV niz_1,#40H
	MOV str_1,#42H
	MOV vys_1,#0FH
	LCALL deleni
	MOV hex_1,nejniz		;uloz data do promennych prevodu hexa-->bcd
	MOV hex_2,niz
	MOV hex_3,str
	LCALL prevod			;preved
	MOV dis,bcd_2			;uloz prevedena data do displeje 
	MOV dis+1,bcd_1
	LJMP pokr_99


;-------------Subrutina "zus_pal"---------------
;tato rutina zajistuje zobrazeni aktualniho stavu paliva na displej
zus_pal:CLR nul_bit
	MOV pretec_up,#0H		;po preteceni pres 9 nuluj
	MOV pretec_down,#9H		;po podteceni zadej 9	
	JB edit,pokr_96
	JNB uloz_bit,pokr_79
	LCALL uloz_pal			;pri pozadavku ulozeni volej rutinu
pokr_79:MOV tecka,#4H			;zobraz tecku
	MOV hex_1,cit_pal2		;proved prevod pocitadla paliva do BCD
	MOV hex_2,cit_pal3
	MOV hex_3,#0H
	LCALL prevod
	MOV dis,bcd_2			;uloz vysledek do promennych displeje
	MOV dis+1,bcd_1
out_12:LJMP pokr_99
pokr_96:LCALL wait
	SJMP out_12

;------------------------Subrutina pro vypocet prumerne spotreby---------
;pocita se podle rovnice 10000000/draha(m)*spotreba(imp)/10000*66667/1000000=prumerna spotreba na 100km (na dosud ujete draze)
prum_spot:CPL pom_bit
	JNB pom_bit,pokr_94
	MOV tecka,#4H			;nacti data pro deleni
	MOV nejniz,#80H
	MOV niz,#96H
	MOV str,#98H
	MOV vys,#0H
	MOV niz_1,drh_1			;nacti 3 byte drahy
	MOV str_1,drh_2
	MOV vys_1,drh_3
	LCALL deleni			;proved deleni

;nasobeni 3x3 byte

	MOV nasob_1,nejniz		;nacti vysledek deleni do promennych rutiny nasobeni
	MOV nasob_2,niz
	MOV nasob_3,str
	MOV nasob_4,cit_pal10		;nacti nejnizsi cast pocitadla impulsu 
	LCALL nasob			;volej rutinu nasobeni
	MOV schov_1,nasob_5		;uloz vysledek
	MOV schov_2,nasob_6
	MOV schov_3,nasob_7
	MOV schov_4,nasob_8
	MOV nasob_4,cit_pal20		;nacti stredni byte pocitadla impulsu,obsazeni nasob_1 az nasob_3 zustava nezmeneno
	LCALL nasob
	MOV A,schov_2			;proved pricteni vysledku druheho dilciho nasobeni k prvnimu
	ADD A,nasob_5			;ulozenemu v schov_1 - schov_4 takto: 1.nasob xx xx xx xx 
	MOV schov_2,A			;   	                 	   2.nasob xx xx xx xx	
	MOV A,schov_3			;		                  ==       xx xx xx xx xx
	ADDC A,nasob_6												
	MOV schov_3,A
	MOV A,schov_4
	ADDC A,nasob_7
	MOV schov_4,A
	MOV schov_5,nasob_8
	MOV nasob_4,cit_pal30		;nacti nejvyssi byte pocitadla impulsu		
	LCALL nasob			
	MOV A,schov_3
	ADD A,nasob_5
	MOV schov_3,A
	MOV A,schov_4
	ADDC A,nasob_6
	MOV schov_4,A
	MOV nejniz,schov_1		;nacti data pro deleni 10000
	MOV niz,schov_2
	MOV str,schov_3
	MOV vys,schov_4
	MOV niz_1,#10H
	MOV str_1,#27H
	MOV vys_1,#0H
	LCALL deleni			;proved deleni
	LJMP pokr_99
	
;nasobeni 3x3 byte

pokr_94:MOV nasob_1,nejniz		
	MOV nasob_2,niz
	MOV nasob_3,str
	MOV nasob_4,#6BH		
	LCALL nasob				
	MOV schov_1,nasob_5		
	MOV schov_2,nasob_6
	MOV schov_3,nasob_7
	MOV schov_4,nasob_8
	MOV nasob_4,#04H		
	LCALL nasob
	MOV A,schov_2			
	ADD A,nasob_5			 
	MOV schov_2,A			
	MOV A,schov_3			
	ADDC A,nasob_6												
	MOV schov_3,A
	MOV A,schov_4
	ADDC A,nasob_7
	MOV schov_4,A
	MOV schov_5,nasob_8
	MOV nasob_4,#01H			
	LCALL nasob			
	MOV A,schov_3
	ADD A,nasob_5
	MOV schov_3,A
	MOV A,schov_4
	ADDC A,nasob_6
	MOV schov_4,A
	MOV nejniz,schov_1
	MOV niz,schov_2
	MOV str,schov_3
	MOV vys,schov_4
	MOV niz_1,#0A0H
	MOV str_1,#86H
	MOV vys_1,#01H
	LCALL deleni
	MOV hex_1,nejniz
	MOV hex_2,niz
	MOV hex_3,str
	LCALL prevod
	MOV dis,bcd_2				
	MOV dis+1,bcd_1
	LJMP pokr_99
	
;---------------Subrutina dat_den zobrazi na displeji znak "d-" a aktualni datum dne------
dat_den:LCALL wait
	CLR P1.2
	MOV pretec_up,#32H		;zadej data preteceni
	MOV pretec_down,#31H
	JB edit,out_11			;pokud jsem v editaci preskoc rutinu
	JNB uloz_bit,pokr_25		;testuj pozadavek ulozeni
	CLR uloz_bit
	MOV R0,#0F6H
	MOV A,uloz_1
	MOVX @R0,A
	INC R0
	MOV A,uloz_2
	MOVX @R0,A
pokr_25:MOV tecka,#0H
	MOV dis,#0BAH			;zobraz d-
	MOV R0,#0F7H			;nacti adresu desitek	
	MOVX A,@R0			;nacti data desitek
	ANL A,#0FH			;vymaskuj
	SWAP A				;prehod do horniho nibble
	MOV dis+1,A			;a uloz
	DEC R0				;sniz adresu na jednotky 
	MOVX A,@R0			;nacti data
	ANL A,#0FH			;vymaskuj neplatnou cast
	ADD A,dis+1			;pricti k desitkam
	MOV dis+1,A			;a uloz do displeje
out_11:	SETB P1.2
	LJMP pokr_99			;ven

;--------------Subrutina dat_mes zobrazi na displeji znak "M-" a aktualni mesic-------
dat_mes:LCALL wait
	CLR P1.2
	MOV pretec_up,#13H		;zadej preteceni
	MOV pretec_down,#12H
	JB edit,out_13			;pri editu preskoc
	JNB uloz_bit,pokr_23		;testuj pozadavek ulozeni
	CLR uloz_bit
	MOV R0,#0F8H
	MOV A,uloz_1
	MOVX @R0,A
	INC R0
	MOV A,uloz_2
	MOVX @R0,A
pokr_23:MOV tecka,#0H
	MOV dis,#0CAH			;zobraz M-
	MOV R0,#0F9H	
	MOVX A,@R0
	ANL A,#0FH	
	SWAP A
	MOV dis+1,A
	DEC R0
	MOVX A,@R0
	ANL A,#0FH
	ADD A,dis+1
	MOV dis+1,A
out_13:	SETB P1.2
	LJMP pokr_99

;-------------Subrutina dat_rok zobrazi na displeji znak "r-" a aktualni rok
dat_rok:LCALL wait
	CLR P1.2
	MOV pretec_up,#00H
	MOV pretec_down,#99H
	JB edit,out_14
	JNB uloz_bit,pokr_22
	CLR uloz_bit
	MOV R0,#0FAH
	MOV A,uloz_1
	MOVX @R0,A
	INC R0
	MOV A,uloz_2
	MOVX @R0,A
pokr_22:MOV tecka,#0H
	MOV dis,#0DAH			;zobraz r-
	MOV R0,#0FBH	
	MOVX A,@R0
	ANL A,#0FH	
	SWAP A
	MOV dis+1,A
	DEC R0
	MOVX A,@R0
	ANL A,#0FH
	ADD A,dis+1
	MOV dis+1,A
out_14:	SETB P1.2
	LJMP pokr_99

;---------------Subrutina dvt=den v tydnu-zobrazi na displeji aktualni den----
;funkce:dle BCD kodu dnu (0-6) nacte z tabulky reprezentaci.Cislo z RTC je nutno nasobit 2
;protoze kazdy den odpovida dvema pismenum
dvt:	CLR nul_bit
	LCALL wait
	CLR P1.2
	MOV pretec_up,#0EFH
	MOV pretec_down,#0CDH
	JB edit,out_10
	JNB uloz_bit,pokr_65		;testuj ulozeni
	CLR uloz_bit			;ano,ukladej horni nibble z dis+1,
	MOV R0,#0FCH			;to je aktualni den z pohledu RTC
	MOV A,uloz_2			;druhe cislo je vzdy o jednu vyssi (kvuli zobrazeni druheho pismena)
	RR A
	MOVX @R0,A
pokr_65:MOV tecka,#0H			;zhasni tecku	
	MOV dis,#0EEH			;zhasni nepotrebne displeje
	MOV DPTR,#dvt_tab		;nacti do DPTR zobrazeni dnu
	MOV R0,#0FCH			;nacti do R0 adresu dnu v RTC
	MOVX A,@R0			;nacti data	
	ANL A,#0FH			;maskuj neplatnou cast bytu
	RL A				;nasob x2	
	MOV R0,A			;uloz do A
	SWAP A				;prehod 
	MOV dis+1,A			;a uloz	do horniho nibble 1. pismeno dne
	MOV A,R0			;znovu nacti adresu 1.dne (v DPTR)
	INC A				;zvys o jednu (na 2. pismeno dne)
	ADD A,dis+1			;a pricti k displeji
	MOV dis+1,A			;uloz
out_10:	SETB P1.2
	LJMP pokr_99

;------------Ulozeni real time---------
;Ulozi editovana data (kvuli BCD funkci RTC rozdelena po cifrach do uloz_10 az uloz_4)
;do hodin a minut a vynuluje vteriny
uloz_real:CLR P1.2
	CLR uloz_bit			;nuluj priznak
	MOV R0,#0F5H			;nacti desitky hodin
	MOV A,uloz_4			;nacti data
	MOVX @R0,A			;a uloz na adresu
	DEC R0
	MOV A,uloz_3
	MOVX @R0,A
	DEC R0
	MOV A,uloz_2
	MOVX @R0,A
	DEC R0
	MOV A,uloz_1
	MOVX @R0,A
	DEC R0
	CLR A
	MOVX @R0,A
	DEC R0
	MOVX @R0,A
	MOV R0,#0FDH			;aktivuj RTC
	MOV A,#00H
	MOVX @R0,A
	INC R0
	MOV A,#02H
	MOVX @R0,A
	INC R0
	MOV A,#04H
	MOVX @R0,A
	SETB P1.2
	RET

;----------------Rutina dalsi----------------
;zajistuje prechod editace na dalsi cifru
dalsi:	JB submenu_bit,out_08		;pokud jsem v submenu,neni mozny posun dis->dis+1
	MOV A,fce			;testuj fci
	CJNE A,#1H,pokr_104		;pokud je realtime
	CPL obeh_bit			;neguj obeh_bit t.j. vymen dis za dis+1
	SJMP out_08			;ven
pokr_104:MOV A,nast			;neni real
	CJNE A,#01H,pokr_101		;testuj pricitane cislo
	CPL obeh_bit			;a pokud je 1(t.j. low nibble) zmen dis
pokr_101:SWAP A				;pokud je pricitane cislo 10 (t.j. high nibble)
	CPL jednicky			;prehod desitky na jednicky
	MOV nast,A			;a uloz
out_08:	RET

;pri ulozeni vysledku editace do zus_pal preved obsah dis,dis+1(uloz_1-uloz_4)
;do hexa a pricti k zustatku.Pokud je zustatek vyssi nez 99.99 l,nepricte se.
;Pokud je zadana hodnota v editu 99.99 l,palivomer se nuluje!!
;Prevod BCD->HEXA pracuje takto:pr. 1234D=1x1000+2x100+3x10+4
;					  1x03E8H+2x64H+3xAH+4

uloz_pal:CLR uloz_bit
	MOV A,dis
	CJNE A,#99H,pokr_83
	MOV A,dis+1
	CJNE A,#99H,pokr_83
	MOV cit_pal1,#0H
	MOV cit_pal2,#0H
	MOV cit_pal3,#0H
	SJMP out_01
pokr_83:MOV nasob_1,#0E8H		;nejvyssi cifru nasob 1000
	MOV nasob_2,#03H	
	MOV nasob_3,#0H
	MOV nasob_4,uloz_4		;nejvyssi editovana cifra
	LCALL nasob			;nasob a uloz
	MOV schov_1,nasob_5
	MOV schov_2,nasob_6
	MOV nasob_1,#64H
	MOV nasob_2,#0H
	MOV nasob_4,uloz_3
	LCALL nasob
	MOV A,nasob_5
	ADD A,schov_1
	MOV schov_1,A
	MOV A,nasob_6
	ADDC A,schov_2
	MOV schov_2,A
	MOV nasob_1,#0AH
	MOV nasob_4,uloz_2
	LCALL nasob
	MOV A,nasob_5
	ADD A,schov_1
	MOV schov_1,A
	MOV A,nasob_6
	ADDC A,schov_2
	MOV schov_2,A
	MOV A,schov_1
	ADD A,uloz_1
	MOV schov_1,A
	MOV A,schov_2
	ADDC A,#0H
	MOV schov_2,A
	MOV schov_3,cit_pal2
	MOV schov_4,cit_pal3
	MOV A,schov_3
	ADD A,schov_1
	MOV schov_1,A
	MOV A,schov_4
	ADDC A,schov_2
	MOV schov_2,A

;test preteceni (9999,pokud je vice,neprovede se ulozeni)
	CJNE A,#27H,pokr_81		;porovnani pres cjne
	MOV A,schov_1			;pokud je rovno,porovnavej dale
	CJNE A,#0FH,pokr_81
pokr_81:JNC out_01			;pokud je ACC mensi,nastav CY
	MOV cit_pal2,schov_1
	MOV cit_pal3,schov_2
out_01:	RET	

;---------------Rutina zpozdeni k nekterym rychlym rutinam--------
wait:	MOV R6,#2H
	MOV R7,#0A5H
pokr_90:DJNZ R7,pokr_90
	MOV R7,#0FFH
	DJNZ R6,pokr_90
	RET


;Tato rutina vypise na displej logo "davi" po resetu
logo:	DJNZ R4,pokr_125			;casovaci smycka pro postupne vypisovani jednotlivych pismen
	MOV R4,schov_4			
	DJNZ R5,out_15
	MOV R5,schov_5			;do R5 zadej parametr pro delsi cas. smycku
	MOV A,schov_5			;podle zadaneho parametru pozna,zda je napis vypsan nebo ne
	CJNE A,#05H,logo_10		;neni
	SJMP logo_9
logo_10:MOV A,dis			;testuj dis
	CJNE A,#0EEH,logo_1		;je "zhasnuto"
	MOV dis,#10H			;rozsvit "d"
	SJMP out_15			
logo_1:	CJNE A,#10H,logo_2		;sviti "d" ? ano,rozsvit "da"
	MOV dis,#12H
	SJMP out_15
logo_2:	MOV A,dis+1			;testuj dis+1
	CJNE A,#0EEH,logo_3		;je "zhasnuto"?
	MOV dis+1,#30H			;rozsvit "v"
	SJMP out_15	
logo_3:	CJNE A,#30H,logo_4		;sviti "v" ? ano,rozsvit "i"
	MOV dis+1,#34H
	LCALL porovnej_den
	JNB logo1_bit,out_15
	LJMP dotaz
logo_4:	MOV schov_5,#05H		;nastav parametr pro delsi casovaci smycku
pokr_125:SJMP out_15

;postupne zhasinani loga
logo_9:	MOV A,dis+1			;testuj zda sviti "vi"
	CJNE A,#34H,logo_5
	MOV dis+1,#30H			;ano,rozsvit "v" resp. zhasni "i"
	SJMP out_15
logo_5:	CJNE A,#30H,logo_6		;testuj zda sviti "v" 
	MOV dis+1,#0H			;zhasni "v"
	SJMP out_15
logo_6:	MOV A,dis
	CJNE A,#12H,logo_7		;testuj zda sviti "da"
	MOV dis,#10H			;ano,rozsvit "d" resp. zhasni "a" 
	SJMP out_15
logo_7:	CJNE A,#10H,logo_8		;testuj zda sviti "d"
	MOV dis,#0H			;ano,zhasni "d"
	SJMP out_15
logo_8:MOV A,#0FDH			;pro vyvolani verze na displej se nejprve aktivuje tranzistor prislusneho tacitka
	MOV R0,#0E0H            	;spolecne s anodou, ale katody jsou vynulovane, proto nic nesviti
	MOVX @R0,A              
	JB P1.0,pokr_118		;otestuj stisk tlacitka (v tomto pripade MODE)
	MOV A,#0FFH			;ano-vypni zpet vsechny tranzistory
	MOVX @R0,A              	;zapis do katod 0EEH,coz je v tabulce adresa pro prazdny znak
	MOV dis,#0EEH
	MOV dis+1,#0EEH
	MOV DPTR,#version		;do DPTR pocatecni adresu tabulky pro zobrazeni verze
	MOV schov_5,#0FH		;nastav zpet zpomalene rozsvicovani loga (parametr casovaci smycky)
	SJMP out_15			;odchod
pokr_118:MOV A,#0FFH			; - tlacitko nestisknuto- vypni vsechny tranzistory,nuluj priznak pro vstup do loga
	MOVX @R0,A              	;a odchod
	CLR logo_bit			;nuluj priznak
	MOV fce,#1H			;prvni zobrazovana fce po zobrazeni loga-real time
out_15:LJMP pokr_99


	
		


;------------------Rutina porovnej_den-----------------
;Tato rutina zajistuje porovnani data dne pri poslednim vyvolani loga-pokud je stejny,blokuje se uvodni pozdrav,jinak 
;nasleduje skok na spusteni pozdravu.
porovnej_den:CLR P1.2			;aktivuj CS RTC
	MOV R0,#0F7H			;nacti adresu desitek	
	MOVX A,@R0			;nacti data desitek
	ANL A,#0FH			;vymaskuj
	SWAP A				;prehod do horniho nibble
	MOV R6,A			;a uloz
	DEC R0				;sniz adresu na jednotky 
	MOVX A,@R0			;nacti data
	ANL A,#0FH			;vymaskuj neplatnou cast
	ADD A,R6			;pricti k desitkam
	SETB P1.2			;deaktivuj CS RTC
	CJNE A,dat_logo,pokr_117	;porovnej nacteny dat.dne s minulym
	CLR logo1_bit			;pri shode nuluj priznak
	RET				;a pokracuj ven
pokr_117:MOV dat_logo,A			;pri neshode aktualizuj ulozeni dne 
	SETB logo1_bit			;nastav priznak a vrat se	
	RET

wav:	JNB wav_bit,wav_skok1		
	MOV SBUF,wav_temp
	CLR TI
wav_skok1:PUSH ACC			;uloz ACC
	PUSH PSW			;uloz stavove slovo
	MOV DP_H,DPH			;uloz DPTR
	MOV DP_L,DPL
	MOV	DPH,wav_start_hi
	MOV	DPL,wav_start_lo	;nacte adresu bajtu
	CLR	A
	MOVC	A,@A+DPTR		;nacte bajt = 2 data
	MOV	wav_temp,A		;uschova
	MOV	A,DPH			;zjisti,zda neni konec
	CJNE	A,wav_end_hi,wav_skok2	;neni konec - pokracuje
	MOV	A,DPL
	CJNE	A,wav_end_lo,wav_skok2	;neni konec
	CLR TI
	CLR wav_bit			;je konec,nuluj flag pro tlacitko
	MOV IE,#8FH			;zakaz preruseni od seriove linky
	CPL wav3_bit
out_99:	MOV DPH,DP_H			;obnov stav DPTR pred vstupem do INT
	MOV DPL,DP_L
	POP PSW				;obnov PSW
	POP ACC				;obnov ACC
	RETI

wav_skok2:CPL wav1_bit
	MOV A,wav_temp
	JB wav1_bit,wav_skok3
	INC	DPTR			;najdi dalsi 2 byte
	MOV	wav_start_hi,DPH
	MOV	wav_start_lo,DPL  	;ulozi adresu bajtu
	ANL A,#0FH
	SJMP wav_skok4
wav_skok3:ANL	A,#0F0H			;necha horni pulku - 1.cislo
	SWAP	A			;da ji dolu
wav_skok4:MOV	DPTR,#wav_tab_dekod	;dekodovaci tabulka
	MOVC	A,@A+DPTR		;nacte data
	MOV	wav_temp,A
	JB wav_bit,out_99
	SETB wav_bit
	MOV SBUF,wav_temp
	CLR TI
	SJMP out_99



;Zde jsou vlozena prevedena data

wav_real_start:
$include(real.asm)
wav_real_end:

wav_provoz_start:
$include(provoz.asm)
wav_provoz_end:

wav_draha_start:
$include(draha.asm)
wav_draha_end:

wav_okamrych_start:
$include(okamrych.asm)
wav_okamrych_end:

wav_prumrych_start:
$include(prumrych.asm)
wav_prumrych_end:

wav_okamspot_start:
$include(okamspot.asm)
wav_okamspot_end:

wav_prumspot_start:
$include(prumspot.asm)
wav_prumspot_end:

wav_zuspal_start:
$include(zuspal.asm)
wav_zuspal_end:

wav_dobryden_start:
$include(dobryden.asm)
wav_dobryden_end:

wav_real:LCALL chod_PCM
	MOV	wav_start_hi,#high(wav_real_start)
	MOV	wav_start_lo,#low(wav_real_start)	;zacatek dat
	MOV	wav_end_hi,#high(wav_real_end)
	MOV	wav_end_lo,#low(wav_real_end)		;konec dat
	RET

wav_provoz:LCALL chod_PCM
	MOV	wav_start_hi,#high(wav_provoz_start)
	MOV	wav_start_lo,#low(wav_provoz_start)	;zacatek dat	
	MOV	wav_end_hi,#high(wav_provoz_end)
	MOV	wav_end_lo,#low(wav_provoz_end)		;konec dat
	RET

wav_draha:LCALL chod_PCM
	MOV	wav_start_hi,#high(wav_draha_start)
	MOV	wav_start_lo,#low(wav_draha_start)	;zacatek dat
	MOV	wav_end_hi,#high(wav_draha_end)
	MOV	wav_end_lo,#low(wav_draha_end)		;konec dat
	RET


wav_okamzita_r:LCALL chod_PCM
	MOV	wav_start_hi,#high(wav_okamrych_start)
	MOV	wav_start_lo,#low(wav_okamrych_start)	;zacatek dat
	MOV	wav_end_hi,#high(wav_okamrych_end)
	MOV	wav_end_lo,#low(wav_okamrych_end)		;konec dat
	RET

wav_prumerna_r:LCALL chod_PCM
	MOV	wav_start_hi,#high(wav_prumrych_start)
	MOV	wav_start_lo,#low(wav_prumrych_start)	;zacatek dat
	MOV	wav_end_hi,#high(wav_prumrych_end)
	MOV	wav_end_lo,#low(wav_prumrych_end)		;konec dat
	RET

wav_zuspal:LCALL chod_PCM
	MOV  wav_start_hi,#high(wav_zuspal_start)
	MOV	wav_start_lo,#low(wav_zuspal_start)	;zacatek dat
	MOV	wav_end_hi,#high(wav_zuspal_end)
	MOV	wav_end_lo,#low(wav_zuspal_end)		;konec dat
	RET

wav_den:MOV	wav_start_hi,#high(wav_dobryden_start)
	MOV	wav_start_lo,#low(wav_dobryden_start)	;zacatek dat
	MOV	wav_end_hi,#high(wav_dobryden_end)
	MOV	wav_end_lo,#low(wav_dobryden_end)		;konec dat
	RET


wav_okamzita_s:LCALL chod_PCM
	MOV	wav_start_hi,#high(wav_okamspot_start)
	MOV	wav_start_lo,#low(wav_okamspot_start)	;zacatek dat
	MOV	wav_end_hi,#high(wav_okamspot_end)
	MOV	wav_end_lo,#low(wav_okamspot_end)		;konec dat
	RET


wav_prumerna_s:LCALL chod_PCM
	MOV	wav_start_hi,#high(wav_prumspot_start)
	MOV	wav_start_lo,#low(wav_prumspot_start)	;zacatek dat
	MOV	wav_end_hi,#high(wav_prumspot_end)
	MOV	wav_end_lo,#low(wav_prumspot_end)		;konec dat
	RET

;testuj beh PCM-pokud bezi(priznak nastaven),neobnovuj hodnotu DPTR pro PCM (poc. a konecnou adresu zvuku)
;program by vzdy po urcite dobe skocil zpet na zacatek,protoze v obsluze TI se pracuje s wav_start_hi a low	
chod_PCM:JNB wav_bit,out_16		;testuj beh PCM,nebezi vrat se do podprogramu ulozeni adresy wav_xxxx		
	DEC SP				;PCM bezi,sniz dvakrat zasobnik pro ziskani
	DEC SP				;navratove adresy do hlavniho programu
out_16:	RET				;proved navrat		 


;-------------Tabulky---------------
	tabznak:        DB 63,6,91,79,102,109,125,7,127,111,64,94,55,80,0
;reprezentace cisel         0,1,2 , 3, 4 , 5 , 6 ,7 ,8 , 9 , -, d, M, r,0

	tabpisma:	DB 0,121,80,80,0,0,0,0,0,0,0,0,0,0,0	
;reprezentace pisma       --,E  ,r ,r

	dvt_tab:	DB 84,121,115,92,62,120,109,120,57,120,115,119,109,92,0
;reprezentace dne	    n  E , P  o , U  t ,  S  t , C  t , P   A ,  S  o,prazdny znak

	tablogo:	DB 0,94,119,28,6,0,0,0,0,0,0,0,0,0,0	
;reprezentace znaku pro logo

;Dekompresni tabulka
wav_tab_dekod:
	db	0,64,80,84,85,87,95,127,128,160,168,170,171,175,191,255

version:	DB 0,28,64,134,91,0,0,0,0,0,0,0,0,0,0
;verse 1.1			^--toto cislo je souctem cifry a reprezentace desetinne tecky kvuli jejimu
;rozsviceni (aby se rozsvitila az s cislem a ne napred)


	END